#include "DxLib.h"
#include "Main.h"
#include "CharMove.h"
#include "Mapping.h"

CCharMove::CCharMove(POINT pt[], float clx, float crx, float cty, float cby, int coltype)
	: Clx(clx), Crx(crx), Cty(cty), Cby(cby),ColType(coltype)
{
	Init();
	for (int i = 0; i < 8; i++) {
		mPt[i].x = pt[i].x;
		mPt[i].y = pt[i].y;
	}
}

void CCharMove::Init() {
	ZeroMemory(mPt, sizeof(mPt));
}

POINT CCharMove::CheckMap(int x, int y) {
	POINT pt[] = {
		{ x + mPt[0].x,	y + mPt[0].y },//
		{ x + mPt[1].x,	y + mPt[1].y },//^
		{ x + mPt[2].x,	y + mPt[2].y },//E

		{ x + mPt[3].x,	y + mPt[3].y },//^
		{ x + mPt[4].x,	y + mPt[4].y },//E^

		{ x + mPt[5].x,	y + mPt[5].y },//
		{ x + mPt[6].x,	y + mPt[6].y },//^
		{ x + mPt[7].x,	y + mPt[7].y },//E
	};
	POINT res = { x, y };
	DWORD cwidth = MapObj.GetChipWidth();
	DWORD cheight = MapObj.GetChipHeight();

	for (int i = 0; i < 8; i++) {
		int index = MapObj.GetValue(1, pt[i].x / MapCell, pt[i].y / MapCell);
		int src_x = (index % MapBitCount) * cwidth;
		int src_y = (index / MapBitCount) * cheight;
		if (src_x == 0 && src_y == 0) // 擾indexǂ
		{
			res.x = pt[i].x / MapCell; // ǂ̍W
			res.y = pt[i].y / MapCell;
			return res; // ǂ̍WԂ
		}
	}
	res.x = -1;
	res.y = -1;
	return res;
}

void CCharMove::MapDraw() {
	DWORD swidth = MapObj.GetMapWidth();
	DWORD sheight = MapObj.GetMapHeight();
	DWORD cwidth = MapObj.GetChipWidth();
	DWORD cheight = MapObj.GetChipHeight();
	DWORD i, j;
	int index, src_x, src_y;
	for (i = 0; i < sheight / MapCell; i++) {
		for (j = 0; j = swidth / MapCell; i++) {
			index = MapObj.GetValue(0, i, j);
			src_x = (index % MapBitCount) * cwidth;
			src_y = (index / MapBitCount) * cheight;
		}
	}
}